package com.example.skola.controller;


import com.example.skola.exception.NotFoundException;
import com.example.skola.request.AddStudentsEventRequest;
import com.example.skola.service.EventService;
import org.springframework.web.bind.annotation.*;
import com.example.skola.dto.EventDto;
import com.example.skola.request.CreateEventRequest;
import com.example.skola.request.AddStudentsEventRequest;
import org.springframework.beans.factory.annotation.Autowired;

import java.time.LocalDateTime;
import java.util.List;
import java.util.stream.Collectors;


@RestController
@RequestMapping("/event")
public class EventController {
    private EventService eventService;

    public EventController(@Autowired EventService eventService) {
        this.eventService = eventService;
    }

    @GetMapping("/init")
    public void init() throws NotFoundException{
        LocalDateTime date = LocalDateTime.of(2024, 7, 3, 12, 0, 0);
        eventService.createEvent(new CreateEventRequest("event1", "retata skuatiiik", "klubovnaa", date));
        LocalDateTime date1 = LocalDateTime.of(2024, 8, 3, 14, 35, 0);
        eventService.createEvent(new CreateEventRequest("event2", "retata big skautik \n next level skuatiiik", "lopusnaaa", date1));

        // add students
        AddStudentsEventRequest request = new AddStudentsEventRequest(1L, List.of(1L, 2L, 3L));
        AddStudentsEventRequest request2 = new AddStudentsEventRequest(2L, List.of(1L, 3L));

        eventService.addStudentsToEvent(request);
        eventService.addStudentsToEvent(request2);


    }

    @PostMapping("/create")
    public EventDto createEvent(@RequestBody CreateEventRequest request) {
        return EventDto.fromEventEntity(eventService.createEvent(request));
    }

    @GetMapping("/all")
    public List<EventDto> getAllEvents() {
        return eventService.getAllEvents()
                .stream()
                .map(EventDto::fromEventEntity)
                .collect(Collectors.toList());
    }

    @GetMapping("/{eventId}/students")
    public List<Long> getStudentsFromEvent(@PathVariable Long eventId) throws NotFoundException {
        return eventService.getStudentIdsFromEvent(eventId);
    }

    @GetMapping("/{eventId}/studentsNames")
    public List<String> getStudentsNamesFromEvent(@PathVariable Long eventId) throws NotFoundException{
        return eventService.getStudentsFromEvent(eventId)
                .stream()
                .map(student -> student.getName())
                .collect(Collectors.toList());
    }

    @PostMapping("/{eventId}/addStudents")
public void addStudentsToEvent(AddStudentsEventRequest request) throws NotFoundException {
        eventService.addStudentsToEvent(request);
    }


}
